package com.biosgallery.floracat;

import com.biosgallery.floracat.domine.Citacions;

import java.util.List;

import okhttp3.ResponseBody;
import retrofit2.Call;
import retrofit2.http.Field;
import retrofit2.http.FormUrlEncoded;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.Path;
import retrofit2.http.Query;


/**
 * Created by xavier on 07/10/17.
 */
public interface ExampleService {

        @GET("albums")
        Call<List<Example>> getAlbums();


        @POST("biocat.EscriuSelectServlet?f6.%json=1")
        @FormUrlEncoded
        Call<ResultatTaxons> savePost(@Field("codi_e_orc") String codiORC,
                            @Field("cusu") String cusu,
                            @Field("els_taxons") String elsTaxons,
                            @Field("especie") String especie,
                            @Field("genere") String genere,
                            @Field("idioma") String idioma,
                            @Field("nivell") String nivell,
                            @Field("nom_taxon") String nomTaxon,
                            @Field("nompopular") String nomPopular,
                            @Field("opcio_anys_futur") String opcioAnysFutur,
                            @Field("opcio_anys_passat") String opcioAnysPassat,
                            @Field("opcio_autors") String opcioAutors,
                            @Field("opcio_bib") String opcioBib,
                            @Field("opcio_exportaciodades") String opcioExportacioDades,
                            @Field("opcio_sql_editable") String opcioSqlEditable,
                            @Field("opcio_temporal") String opcioTemporal,
                            @Field("opcio_utm1x1") String opcioUtm1x1,
                            @Field("pop_sci") String popSci,
                            @Field("screenWidth") String screenWidth,
                            @Field("subsp") String subsp,
                            @Field("taxonName") String taxonName,
                            @Field("taxonPopular") String taxonPopular
                            );

        @POST("biocat.SSBPBTServlet?f4.05%nomestab=1")
        @FormUrlEncoded
        Call<String> getTaxon(@Field("cusu") String cusu,
                             @Field("idioma") String idioma,
                             @Field("opcio_autors") String opcioAutors,
                             @Field("opcio_bib") String opcioBib,
                             @Field("opcio_utm1x1") String opcioUtm1x1,
                             @Field("origen") String origen,
                             @Field("screenWidth") String screenWidth,
                             @Field("stat_orni") String statOrni,
                             @Field("taxon") String codiTaxon
        );

       // String baseURL = "http://biodiver.bio.ub.es/biocat/";f6.%codi_e_orc
        @GET("/biocat/FdistJSON")
        Call<Citacions> getUTMDades(@Query(value = "f6.%codi_e_orc",encoded = true) String codeTaxon);

        @GET("/Cormofits/imatges/thumbs/{fileName}")
        Call<ResponseBody> downloadImage(@Path("fileName") String fileName);


}


