package com.biosgallery.floracat.activities;

import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.SearchView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Switch;
import android.widget.Toast;
import android.widget.ToggleButton;

import com.biosgallery.floracat.ExampleService;
import com.biosgallery.floracat.R;
import com.biosgallery.floracat.ResultatTaxons;
import com.biosgallery.floracat.domine.Taxon;

import org.apache.commons.lang3.text.WordUtils;

import java.util.List;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;

import static java.security.AccessController.getContext;

public class CercaTaxonActivity extends AppCompatActivity {

    private ResultatTaxons rt = new ResultatTaxons();
    ListView sl,lv;
    AppCompatActivity th = this;
    SearchView simpleSearchView;
    ToggleButton tBCientPopu;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.llista_taxons);


        lv = (ListView) findViewById(R.id.llistaSample);

        View headerView = ((LayoutInflater)this.getSystemService(this.LAYOUT_INFLATER_SERVICE)).inflate(R.layout.headerlist, null, false);
        lv.addHeaderView(headerView);


        simpleSearchView = (SearchView) findViewById(R.id.simpleSearchView); // inititate a search view

        cercarTaxon(simpleSearchView);

        simpleSearchView.setOnQueryTextListener(new SearchView.OnQueryTextListener() {

            @Override
            public boolean onQueryTextSubmit(String query) {
                cercarTaxon(simpleSearchView);
                return false;
            }

            @Override
            public boolean onQueryTextChange(String newText) {

                return false;
            }
        });


        lv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                //obtengo el valor del string del elemento donde se hizo clic
                Taxon itemValue = (Taxon) lv.getItemAtPosition(position);

                //Con el fin de empezar a mostrar una nueva actividad lo que necesitamos es una intención
                Intent intent = new Intent(getApplicationContext(),FitxaBio_Activity.class);

                intent.putExtra("codeTaxon", itemValue.getValue());
                intent.putExtra("nomTaxon", itemValue.getTaxon());
                // Aquí pasaremos el parámetro de la intención creada previamente
                startActivity(intent);
            }
        });
    }



    public void cercarTaxon(android.support.v7.widget.SearchView ssview) {
        String baseURL = "http://biodiver.bio.ub.es/biocat/servlet/";
        Retrofit retrofit = new Retrofit.Builder().baseUrl(baseURL)
                .addConverterFactory(GsonConverterFactory.create())
                .build();

        ExampleService exSer = retrofit.create(ExampleService.class);


        Switch simpleSwitch = (Switch) findViewById(R.id.switch1);

        Call<ResultatTaxons> lista;

        if (!simpleSwitch.isChecked()) {
            String nomPopular = WordUtils.capitalize(ssview.getQuery().toString());
            if ("".equals(nomPopular)) { nomPopular = " "; }

            lista = exSer.savePost("","","","","","","","",WordUtils.capitalize(ssview.getQuery().toString()),"2017","1700","false","true","0","false","false","false","nompopular","","","","");
        } else {
            lista = exSer.savePost("","","","",WordUtils.capitalize(ssview.getQuery().toString()),"","","","","2017","1700","false","true","0","false","false","false","genere_especie_subsp","","","","");
        }



        lista.enqueue(new Callback<ResultatTaxons>() {
            @Override
            public void onResponse(@NonNull Call<ResultatTaxons> call, @NonNull Response<ResultatTaxons> response) {
                if (response.isSuccessful()) {
                    rt = response.body();

                    sl = (ListView) findViewById(R.id.llistaSample);

                    List<Taxon> output;
                    output = rt.getTaxons();

                    ArrayAdapter<Taxon> adaptador = new ArrayAdapter<>(th, android.R.layout.simple_list_item_1, android.R.id.text1, output);
                    sl.setAdapter(adaptador);
                }

            }

            @Override
            public void onFailure(@NonNull Call<ResultatTaxons> call, @NonNull Throwable t) {
                Log.i("onEmptyResponse", "failuere");
                Toast toast1 = Toast.makeText(getApplicationContext(), "No hi ha conexió, valideu el accés a les dades mòbils", Toast.LENGTH_SHORT);
                toast1.show();
            }
        });
    }
}
