package com.biosgallery.floracat.activities;

import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.design.widget.TabLayout;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;

import com.biosgallery.floracat.R;
import com.biosgallery.floracat.activities.fragments.FitxaBioDades;
import com.biosgallery.floracat.activities.fragments.FitxaBioImages;
import com.biosgallery.floracat.activities.fragments.FitxaBioMapa;
import com.biosgallery.floracat.domine.Citacions;
import com.biosgallery.floracat.domine.CitationList;
import com.biosgallery.floracat.domine.Troballa;
import com.biosgallery.floracat.util.DBHandler;

import java.util.ArrayList;
import java.util.List;

public class FitxaBio_Activity extends AppCompatActivity implements ComunicacioFitxaBio {

    /**
     * The {@link android.support.v4.view.PagerAdapter} that will provide
     * fragments for each of the sections. We use a
     * {@link FragmentPagerAdapter} derivative, which will keep every
     * loaded fragment in memory. If this becomes too memory intensive, it
     * may be best to switch to a
     * {@link android.support.v4.app.FragmentStatePagerAdapter}.
     */
    private SectionsPagerAdapter mSectionsPagerAdapter;
    String codeTaxon = new String();
    String nomTaxon = new String();
    private final String baseURL = "http://biodiver.bio.ub.es/biocat/";
    private Citacions ct = new Citacions();
    private List<CitationList> lct;

    /**
     * The {@link ViewPager} that will host the section contents.
     */
    private ViewPager mViewPager;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_fitxabio);

        Bundle datos = this.getIntent().getExtras();
        codeTaxon = datos.getString("codeTaxon");
        nomTaxon = datos.getString("nomTaxon");

        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        // Create the adapter that will return a fragment for each of the three
        // primary sections of the activity.
        mSectionsPagerAdapter = new SectionsPagerAdapter(getSupportFragmentManager());

        // Set up the ViewPager with the sections adapter.
        mViewPager = (ViewPager) findViewById(R.id.container);
        mViewPager.setAdapter(mSectionsPagerAdapter);
        mViewPager.setOffscreenPageLimit(3);

        TabLayout tabLayout = (TabLayout) findViewById(R.id.tabs);
        tabLayout.setupWithViewPager(mViewPager);


        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fabFB);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                //Con el fin de empezar a mostrar una nueva actividad lo que necesitamos es una intención
                Intent intent = new Intent(getApplicationContext(),TroballaDetailActivity.class);

                intent.putExtra("codeTaxon", codeTaxon);
                intent.putExtra("nomTaxon", nomTaxon);
                // Aquí pasaremos el parámetro de la intención creada previamente
                intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_MULTIPLE_TASK);
                startActivity(intent);

            }
        });


    }

    /**
     * A {@link FragmentPagerAdapter} that returns a fragment corresponding to
     * one of the sections/tabs/pages.
     */
    public class SectionsPagerAdapter extends FragmentPagerAdapter {

        public SectionsPagerAdapter(FragmentManager fm) {
            super(fm);
        }

        @Override
        public Fragment getItem(int position) {

            switch (position) {
                case 0:
                    Bundle bundle = new Bundle();
                    bundle.putString("codeTaxon", codeTaxon);
                    bundle.putString("nomTaxon",nomTaxon);
                    FitxaBioDades fragInfo = new FitxaBioDades();
                    fragInfo.setArguments(bundle);
                    //FitxaBioDades fragInfo = new FitxaBioDades();
                    return fragInfo;

                case 1:
                    FitxaBioImages tab2 = new FitxaBioImages();
                    return tab2;

                case 2:
                    FitxaBioMapa tab3 = new FitxaBioMapa();
                    return tab3;
                default:
                    return null;
            }


        }

        @Override
        public int getCount() {
            // Show 3 total pages.
            return 3;
        }

        @Override
        public CharSequence getPageTitle(int position) {
            switch (position) {
                case 0:
                    return "Dades";
                case 1:
                    return "Imatges";
                case 2:
                    return "Mapa";
            }
            return null;
        }

        public Fragment getFragmentForPosition(int position)
        {
            String tag = makeFragmentName(mViewPager.getId(), getItemId(position));
            Fragment fragment = getSupportFragmentManager().findFragmentByTag(tag);
            return fragment;
        }

        public String makeFragmentName(int containerViewId, long id) {
            return "android:switcher:" + containerViewId + ":" + id;
        }
    }


    public void responImatges(ArrayList<String> images) {
        FitxaBioImages fBI = (FitxaBioImages) mSectionsPagerAdapter.getFragmentForPosition( 1);
        fBI.LoadImages(images);
    }

    public String getCodiTaxon() {
        return codeTaxon;
    }


    public String getNomTaxon() {
        return nomTaxon;
    }
}
