package com.biosgallery.floracat.activities;

import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.preference.PreferenceManager;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.FragmentActivity;
import android.os.Bundle;
import android.support.v4.app.FragmentManager;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import com.biosgallery.floracat.R;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

import static java.security.AccessController.getContext;

public class TriarPosicio extends FragmentActivity implements OnMapReadyCallback, GoogleMap.OnMapClickListener,LocationListener {

    private GoogleMap mMap;
    private LatLng coordenada;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_triar_posicio);
        // Obtain the SupportMapFragment and get notified when the map is ready to be used.
        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager()
                .findFragmentById(R.id.map);

        mapFragment.getMapAsync(this);


        if ( getIntent().getParcelableExtra("COORDENADA") != null) {
            coordenada = getIntent().getParcelableExtra("COORDENADA");
        }
    }


    /**
     * Manipulates the map once available.
     * This callback is triggered when the map is ready to be used.
     * This is where we can add markers or lines, add listeners or move the camera. In this case,
     * we just add a marker near Sydney, Australia.
     * If Google Play services is not installed on the device, the user will be prompted to install
     * it inside the SupportMapFragment. This method will only be triggered once the user has
     * installed Google Play services and returned to the app.
     */
    @Override
    public void onMapReady(GoogleMap googleMap) {
        mMap = googleMap;


        mMap.getUiSettings().setCompassEnabled(true);
        mMap.getUiSettings().setRotateGesturesEnabled(true);
        mMap.getUiSettings().setZoomControlsEnabled(true);
        mMap.getUiSettings().setMyLocationButtonEnabled(true);
        mMap.setMyLocationEnabled(true);

        SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(this);
        String mapDisplay = sharedPref.getString("example_list", "");

        if ("-1".equals(mapDisplay)) {
            mMap.setMapType(GoogleMap.MAP_TYPE_TERRAIN);
        } else if ("0".equals(mapDisplay)) {
            mMap.setMapType(GoogleMap.MAP_TYPE_SATELLITE);
        } else if ("1".equals(mapDisplay)) {
            mMap.setMapType(GoogleMap.MAP_TYPE_HYBRID);
        }



        if (ContextCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            // TODO: Consider calling
            //    ActivityCompat#requestPermissions
            // here to request the missing permissions, and then overriding
            //   public void onRequestPermissionsResult(int requestCode, String[] permissions,
            //                                          int[] grantResults)
            // to handle the case where the user grants the permission. See the documentation
            // for ActivityCompat#requestPermissions for more details.
            Toast.makeText(this.getApplicationContext(), "First enable LOCATION ACCESS in settings.", Toast.LENGTH_LONG).show();
            return;
        }
        LocationManager locManager = (LocationManager)getSystemService(LOCATION_SERVICE);

        locManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 100, 1, this);

        mMap.moveCamera(CameraUpdateFactory.newLatLngZoom(new LatLng(41.765208d, 1.621122d), 7));

        mMap.clear();
        if (coordenada != null) {
            mMap.addMarker(new MarkerOptions().position(coordenada).title(getString(R.string.posicioTriada)));
        }
        mMap.setOnMapClickListener(this);
    }

    @Override
    public void onProviderEnabled( final String provider ) {

   }

    @Override
    public void onProviderDisabled(String s) {
        Toast.makeText(this.getApplicationContext(), "First enable LOCATION ACCESS in settings.", Toast.LENGTH_LONG).show();
    }


    @Override
    public void onStatusChanged(String s, int i, Bundle bundle) {

    }

    @Override
    public void onLocationChanged(Location location) {

    }

    @Override
    public void onMapClick(LatLng position) {
        Toast.makeText(this,"Lat: "+position.latitude + ", Long: " + position.longitude,Toast.LENGTH_SHORT).show();
        coordenada = position;
        mMap.clear();
        mMap.addMarker(new MarkerOptions().position(position).title("Posició Triada"));

    }


    public void tornarTroballa(View v) {
        Intent intent = new Intent();
        intent.putExtra("editTextValue", coordenada);
        setResult(RESULT_OK, intent);
        finish();
    }

}
