package com.biosgallery.floracat.activities.fragments;

/**
 * Created by xavier on 11/11/17.
 */

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;
import android.widget.Toast;

import com.biosgallery.floracat.domine.DadesTaxon;
import com.biosgallery.floracat.ExampleService;
import com.biosgallery.floracat.R;
import com.biosgallery.floracat.activities.ComunicacioFitxaBio;
import com.biosgallery.floracat.domine.Citacions;
import com.google.gson.Gson;

import org.json.JSONObject;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.util.ArrayList;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;
import retrofit2.converter.scalars.ScalarsConverterFactory;


public class FitxaBioDades extends Fragment {

    private final String baseURL = "http://biodiver.bio.ub.es/biocat/servlet/";
    private TextView tv, familia, ecologia, formaBio,distrBioGeo, distPrin, freq, alcada, floracio, tipusSol,fitosociologia, mida, nom, nomPopular, observacions,estatAlt;
    private ArrayList<String> images = null;
    private ComunicacioFitxaBio comunic;
    private Citacions ct = new Citacions();

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_fitxabio_dades, container, false);

        Toast toast1 = Toast.makeText(getContext(), R.string.cargaDades, Toast.LENGTH_SHORT);
        toast1.show();

        Retrofit retrofit = new Retrofit.Builder().baseUrl(baseURL)
                .addConverterFactory(ScalarsConverterFactory.create())
                .addConverterFactory(GsonConverterFactory.create())
                .build();

        ExampleService exSer = retrofit.create(ExampleService.class);

        String codeTaxon = getArguments().getString("codeTaxon");
        String nomTaxon = getArguments().getString("nomTaxon");

        familia = (TextView) rootView.findViewById(R.id.familia);
        ecologia = (TextView) rootView.findViewById(R.id.ecologia);
        formaBio = (TextView) rootView.findViewById(R.id.formBio);
        distrBioGeo = (TextView) rootView.findViewById(R.id.distBioGeo);
        distPrin = (TextView) rootView.findViewById(R.id.distPrin);
        freq = (TextView) rootView.findViewById(R.id.freq);
        alcada = (TextView) rootView.findViewById(R.id.Alcada);
        floracio = (TextView) rootView.findViewById(R.id.floracio);
        tipusSol = (TextView) rootView.findViewById(R.id.tipusSol);
        fitosociologia = (TextView) rootView.findViewById(R.id.fitosociologia);
        mida = (TextView) rootView.findViewById(R.id.mida);
        nom = (TextView) rootView.findViewById(R.id.nom);
        nomPopular = (TextView) rootView.findViewById(R.id.nomPopular);
        observacions = (TextView) rootView.findViewById(R.id.observacions);
        estatAlt  = (TextView) rootView.findViewById(R.id.estatgeAlt);

         nom.setText(nomTaxon);




        Call<String> lista = exSer.getTaxon("","CAT","false","true","false","","1920","","@taxon@%codi_e_orc="+codeTaxon+"%codi_espe=000397%nivell=SP");




        lista.enqueue(new Callback<String>() {
            @Override
            public void onResponse(Call<String> call, Response<String> response) {
                Log.i("Response", response.body().toString());
                if (response.isSuccessful()) {
                    String rt = response.body();

                    JSONObject jO = getJsonData(rt);

                    Gson gson = new Gson();

                    DadesTaxon dtax = gson.fromJson(jO.toString(), DadesTaxon.class);

                    //començara atreballar amb dtax
                    //seguir amb la refactorització del codi

                    familia.setText("  "+((dtax.getFamLia()==null)? " ":dtax.getFamLia()));
                    ecologia.setText("  "+((dtax.getEcologia()==null)? " ":dtax.getEcologia()));
                    formaBio.setText("  "+((dtax.getFormaBiolGica()==null)? " ":dtax.getFormaBiolGica()));
                    distrBioGeo.setText(((dtax.getDistribuciBiogeogrFica()==null)? " ":dtax.getDistribuciBiogeogrFica()));
                    distPrin.setText(((dtax.getDistribuciAlPrincipat()==null)? " ":dtax.getDistribuciAlPrincipat()));
                    freq.setText("  "+((dtax.getFreqNcia()==null)? " ":dtax.getFreqNcia()));
                    alcada.setText("  "+((dtax.getDistribuciAltitudinal()==null)? " ": (dtax.getDistribuciAltitudinal().contains("/a>")) ?  dtax.getDistribuciAltitudinal().substring(3): dtax.getDistribuciAltitudinal()));
                    estatAlt.setText(((dtax.getEstatgesAltitudinals()==null)? " ":dtax.getEstatgesAltitudinals()));
                    floracio.setText("  "+((dtax.getFloraci()==null)? " ":dtax.getFloraci()));
                    tipusSol.setText("  "+((dtax.getTipusDeSL()==null)? " ":dtax.getTipusDeSL()));
                    fitosociologia.setText(((dtax.getAdscripciFitosociolGica()==null)? " ":dtax.getAdscripciFitosociolGica()));
                    mida.setText("  "+ ((dtax.getMida()==null)? " ":dtax.getMida()));
                    nomPopular.setText("  "+ ((dtax.getNomsPopulars()==null || "/a>".equals(dtax.getNomsPopulars()))? " ":(dtax.getNomsPopulars().contains("/a>")) ?  dtax.getNomsPopulars().substring(3): dtax.getNomsPopulars()));
                    observacions.setText("  "+ ((dtax.getObservacions()==null)? " ":dtax.getObservacions()));
               } else {
                    Log.i("onEmptyResponse", "Returned empty response");
                    Toast toast1 = Toast.makeText(getContext(), getString(R.string.ERR_NO_DADES), Toast.LENGTH_SHORT);
                    toast1.show();
                }

            }


            @Override
            public void onFailure(Call<String> call, Throwable t) {
                t.getCause();
                Toast toast1 = Toast.makeText(getContext(),getString(R.string.ERR_SENSE_CONEXIO), Toast.LENGTH_SHORT);
                toast1.show();
            }
        });




        return rootView;
    }




    private JSONObject getJsonData(String textHTML) {
        Document doc = Jsoup.parse(textHTML);
        String text = doc.select("td").html();

        JSONObject jsonParentObject = new JSONObject();
        JSONObject jsonObject = new JSONObject();

        try {
            String[] textSplitResult = text.split("<br>");
            if (null != textSplitResult) {
                for (String t : textSplitResult) {
                    Document d = Jsoup.parse(t);
                    String t1 = d.select("b").text();
                    if (t1.length() != 0){
                        t1 = t1.substring(0,t1.length()-1);
                        String t2 = d.html();
                        String t3 = t2.substring(t2.indexOf(t1)+t1.length()+6,t2.indexOf("</body>")-2);

                        jsonObject.put(t1, t3);

                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        text = doc.select("img").html();


        Elements img = doc.getElementsByTag("img");
        images = new ArrayList<String>(img.size());
        int i = 0;
        for (Element el : img) {
            images.add(i,el.attr("SRC"));
            i++;
        }

        comunic.responImatges(images);

        return jsonObject;
    }


    @Override
    public void onActivityCreated(@Nullable Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

        comunic = (ComunicacioFitxaBio) getActivity();
    }
}
