package com.biosgallery.floracat.activities.fragments;

/**
 * Created by xavier on 11/11/17.
 */

import android.Manifest;
import android.content.DialogInterface;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.Fragment;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import com.biosgallery.floracat.ExampleService;
import com.biosgallery.floracat.R;
import com.biosgallery.floracat.activities.ComunicacioFitxaBio;
import com.biosgallery.floracat.domine.Citacions;
import com.biosgallery.floracat.domine.CitationList;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapView;
import com.google.android.gms.maps.model.LatLng;

import java.util.ArrayList;
import java.util.List;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;


public class FitxaBioMapa extends Fragment {

    MapView mMapView;
    private GoogleMap googleMap;
    ArrayList<LatLng> markerPoints;
    private final String baseURL = "http://biodiver.bio.ub.es/biocat/";
    private ComunicacioFitxaBio comunic;
    private Citacions ct = new Citacions();
    private List<CitationList> lct;
    public WebView mWebView;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_fitxabio_mapa, container, false);


        comunic = (ComunicacioFitxaBio) getActivity();

/*

        mMapView= (MapView) rootView.findViewById(R.id.mapView);
        mMapView.onCreate(savedInstanceState);

        mMapView.onResume();

        try {
            MapsInitializer.initialize(getActivity().getApplicationContext());
        } catch (Exception e) {
            e.printStackTrace();
        }

        mMapView.getMapAsync(new OnMapReadyCallback() {
            @Override
            public void onMapReady(GoogleMap mMap) {
                googleMap = mMap;


                if (checkLocationPermission()) {
                    if (ContextCompat.checkSelfPermission(getActivity(),
                            Manifest.permission.ACCESS_FINE_LOCATION)
                            == PackageManager.PERMISSION_GRANTED) {

                        //Request location updates:
                        googleMap.setMyLocationEnabled(true);
                    }
                }


                markerPoints = new ArrayList<LatLng>();

                googleMap.getUiSettings().setCompassEnabled(true);
                googleMap.getUiSettings().setMyLocationButtonEnabled(true);
                googleMap.getUiSettings().setRotateGesturesEnabled(true);

                googleMap.moveCamera(CameraUpdateFactory.newLatLngZoom(new LatLng(41.765208d, 1.621122d), 7));

            }
        });


        getUTMData(comunic.getCodiTaxon());


        */

        comunic.getNomTaxon();
      //  mWebView = (WebView) rootView.findViewById(R.id.webview);




        final WebView webview = (WebView)rootView.findViewById(R.id.webview);
        /* JavaScript must be enabled if you want it to work, obviously */
        webview.getSettings().setJavaScriptEnabled(true);

        /* WebViewClient must be set BEFORE calling loadUrl! */
        webview.setWebViewClient(new WebViewClient() {
            @Override
            public void onPageFinished(WebView view, String url)
            {
               // webview.loadUrl("javascript:$('#source_logo').css('display', 'none');$('h1').css('display', 'none');$('#rounded_box').css('padding', '5px');$('#rounded_box').on('shown.bs.tab', function () {google.maps.event.trigger(window, 'resize', {}); });");
                webview.loadUrl("javascript:$('#source_logo').css('display', 'none');$('#rounded_box').css('padding', '0px');$('#rounded_box').on('shown.bs.tab', function () {google.maps.event.trigger(window, 'resize', {}); });");
            }
        });

        webview.loadUrl("http://biodiver.bio.ub.es/bdbc/Citation?action=map&taxon=+"+comunic.getNomTaxon().replace(" ","+"));

        return rootView;
    }



    public boolean checkLocationPermission() {
        if (ContextCompat.checkSelfPermission(getActivity(),
                Manifest.permission.ACCESS_FINE_LOCATION)
                != PackageManager.PERMISSION_GRANTED) {

            // Should we show an explanation?
            if (ActivityCompat.shouldShowRequestPermissionRationale(getActivity(),
                    Manifest.permission.ACCESS_FINE_LOCATION)) {

                // Show an explanation to the user *asynchronously* -- don't block
                // this thread waiting for the user's response! After the user
                // sees the explanation, try again to request the permission.
                new AlertDialog.Builder(getActivity())
                        .setTitle("")
                        .setMessage("")
                        .setPositiveButton("Ok", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialogInterface, int i) {
                                //Prompt the user once explanation has been shown
                                ActivityCompat.requestPermissions(getActivity(),new String[]
                                        {Manifest.permission.ACCESS_FINE_LOCATION},1);
                            }
                        })
                        .create()
                        .show();


            } else {
                // No explanation needed, we can request the permission.
                ActivityCompat.requestPermissions(getActivity(),
                        new String[]{Manifest.permission.ACCESS_FINE_LOCATION}, 1);
            }
            return false;
        } else {
            return true;
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           String permissions[], int[] grantResults) {
        switch (requestCode) {
            case 1:
            {
                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {

                    // permission was granted, yay! Do the
                    // location-related task you need to do.
                    if (ContextCompat.checkSelfPermission(getActivity(),
                            Manifest.permission.ACCESS_FINE_LOCATION)
                            == PackageManager.PERMISSION_GRANTED) {


                        googleMap.setMyLocationEnabled(true);
                    }

                } else {



                }
                return;
            }

        }
    }

    private void getUTMData(String taxon) {

        // https://www.youtube.com/watch?v=4MPuoOj5TIw

        Retrofit retrofit = new Retrofit.Builder().baseUrl(baseURL)
                .addConverterFactory(GsonConverterFactory.create())
                .build();


        ExampleService exSer = retrofit.create(ExampleService.class);


        Call<Citacions> cit = exSer.getUTMDades(taxon);


        cit.enqueue(new Callback<Citacions>() {
            @Override
            public void onResponse(Call<Citacions> call, Response<Citacions> response) {
                if (response.isSuccessful()) {
                    Log.i("Response", response.body().toString());
                    ct = response.body();

                    lct = ct.getCitationList();

                    //for (CitationList cl : lct )
                    //}


                } else {
                    Log.i("onEmptyResponse", "Returned empty response");
                }

            }


            @Override
            public void onFailure(Call<Citacions> call, Throwable t) {
                t.getCause();
            }
        });

    }




}
