package com.biosgallery.floracat.util;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;


import com.biosgallery.floracat.R;
import com.biosgallery.floracat.domine.MainMenuItem;

import java.util.ArrayList;

public class CustomGridViewAdapter extends android.widget.ArrayAdapter<MainMenuItem> {
 private Context context;
 int layoutResourceId;
 private ArrayList<MainMenuItem> data = new ArrayList<MainMenuItem>();
	private int[] colors = new int[] { 0x30FF0000, 0x300000FF };
 
 public CustomGridViewAdapter(Context context, int layoutResourceId, ArrayList<MainMenuItem> data) {
	 super(context, layoutResourceId, data);
	 this.layoutResourceId = layoutResourceId;
	 this.context = context;
	 this.data = data;
 }

 @Override
 public View getView(int position, View convertView, ViewGroup parent) {
	  View row = convertView;
	  RecordHolder holder = null;


	 
	  if (row == null) {
		  LayoutInflater inflater = ((Activity) context).getLayoutInflater();
		  row = inflater.inflate(layoutResourceId, parent, false);
		  holder = new RecordHolder();
		  holder.txtTitle = (TextView) row.findViewById(R.id.item_text);
		  holder.imageItem = (ImageView) row.findViewById(R.id.item_image);
		  row.setTag(holder);
	  } else {
		  holder = (RecordHolder) row.getTag();
	  }
	 
	  MainMenuItem item = data.get(position);
	  holder.txtTitle.setText(item.getText());
	  holder.imageItem.setImageDrawable(item.getImage());

		 int colorPos = position % colors.length;
		 row.setBackgroundColor(colors[colorPos]);

	 if (position == 2) {
         row.setBackgroundColor(context.getResources().getColor(R.color.colorProb));
	 } else if (position == 3) {
		 row.setBackgroundColor(context.getResources().getColor(R.color.colorConf));
	 } else if (position == 0) {
         row.setBackgroundColor(context.getResources().getColor(R.color.colorCerca));
     } else if (position == 1) {
         row.setBackgroundColor(context.getResources().getColor(R.color.colorBloc));
     }

	  return row;
	 
 }
 
 static class RecordHolder {
	 TextView txtTitle;
	 ImageView imageItem;
 }
}

